Index: doc/graph-adaptors.dox
===================================================================
--- doc/graph-adaptors.dox	(revision 1949)
+++ doc/graph-adaptors.dox	(revision 2084)
@@ -37,6 +37,6 @@
    \code
    ListGraph g;
-   RevGraphAdaptor<ListGraph> rgw(g);
-   int result=algorithm(rgw);
+   RevGraphAdaptor<ListGraph> rga(g);
+   int result=algorithm(rga);
    \endcode
    After running the algorithm, the original graph \c g 
@@ -59,5 +59,5 @@
    meaningless. This means that the concepts that they are models of depend 
    on the graph adaptor, and the wrapped graph(s). 
-   If an edge of \c rgw is deleted, this is carried out by 
+   If an edge of \c rga is deleted, this is carried out by 
    deleting the corresponding edge of \c g, thus the adaptor modifies the 
    original graph. 
@@ -74,6 +74,6 @@
    \code
    int algorithm1(const ListGraph& g) {
-   RevGraphAdaptor<const ListGraph> rgw(g);
-   return algorithm2(rgw);
+   RevGraphAdaptor<const ListGraph> rga(g);
+   return algorithm2(rga);
    }
    \endcode
Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 2072)
+++ doc/groups.dox	(revision 2084)
@@ -15,11 +15,12 @@
 and thereafter the program code can be made efficient by small modifications. 
 
-The most efficient implementation of diverse applications require the usage of different physical graph implementations. These differences appear in the size of 
-graph we require to handle, memory or time usage limitations or in 
-the set of operations through which the graph can be accessed. 
-LEMON provides several physical graph structures to meet the 
-diverging requirements of the possible users. 
-In order to save on running time or on memory usage, some structures may 
-fail to provide some graph features like edge or node deletion.
+The most efficient implementation of diverse applications require the
+usage of different physical graph implementations. These differences
+appear in the size of graph we require to handle, memory or time usage
+limitations or in the set of operations through which the graph can be
+accessed.  LEMON provides several physical graph structures to meet
+the diverging requirements of the possible users.  In order to save on
+running time or on memory usage, some structures may fail to provide
+some graph features like edge or node deletion.
 
 Alteration of standard containers need a very limited number of 
@@ -77,5 +78,5 @@
 
 Most of them are \ref lemon::concept::ReadMap "ReadMap"s. They can
-make arithmetic oprerations between one or two maps (negation, scalig,
+make arithmetic oprerations between one or two maps (negation, scaling,
 addition, multiplication etc.) or e.g. convert a map to another one
 of different Value type.
@@ -87,8 +88,22 @@
 \brief Two dimensional data storages.
 
-Two dimensional
-data storages.
-*/
-
+Two dimensional data storages.
+*/
+
+/**
+@defgroup paths Path Structures
+@ingroup datas
+\brief Path structures implemented in LEMON.
+
+LEMON provides flexible data structures
+to work with paths.
+
+All of them have the same interface, especially they can be built or extended
+using a standard Builder subclass. This make is easy to have e.g. the Dijkstra
+algorithm to store its result in any kind of path structure.
+
+\sa lemon::concept::Path
+
+*/
 
 /**
@@ -111,9 +126,9 @@
 
 /**
-@defgroup galgs Graph Algorithms
-\brief This group describes the several graph algorithms
+@defgroup algs Algorithms
+\brief This group describes the several algorithms
 implemented in LEMON.
 
-This group describes the several graph algorithms
+This group describes the several algorithms
 implemented in LEMON.
 */
@@ -121,8 +136,70 @@
 /**
 @defgroup gutils General Graph Utilities
-@ingroup galgs
+@ingroup algs
 \brief This group describes some simple general graph utilities.
 
 This group describes some simple general graph utilities.
+*/
+
+/**
+@defgroup flowalgs Path and Flow Algorithms
+@ingroup algs
+\brief This group describes the algorithms
+for finding paths and flows in graphs.
+
+This group describes the algorithms
+for finding paths and flows in graphs.
+
+\image html flow.png
+\image latex flow.eps "Graph flow" width=\textwidth
+*/
+
+/**
+@defgroup topology Topology related algorithms
+@ingroup algs
+\brief This group describes the algorithms
+for discover the topology of the graphs.
+
+This group describes the algorithms
+for discover the topology of the graphs.
+
+\image html edge_biconnected_components.png
+\image latex edge_biconnected_components.eps "bi-edge-connected components" width=\textwidth
+
+*/
+
+/**
+@defgroup matching Matching algorithms in graphs and bipartite graphs
+@ingroup algs
+\brief This group describes the algorithms
+for find matchings in graphs and bipartite graphs.
+
+This group provides some algorithm objects and function
+to calculate matchings in graphs and bipartite graphs.
+
+\image html bipartite_matching.png
+\image latex bipartite_matching.eps "Bipartite Matching" width=\textwidth
+
+*/
+
+/**
+@defgroup spantree Minimum Cost Spanning Tree Algorithms
+@ingroup algs
+\brief This group containes the algorithms for finding a minimum cost spanning
+tree in a graph
+
+This group containes the algorithms for finding a minimum cost spanning
+tree in a graph
+*/
+
+
+/**
+@defgroup auxalg Auxiliary Algorithms
+@ingroup algs
+\brief Some algorithms implemented in LEMON.
+
+This group describes the algorithms in LEMON in order to make 
+it easier to implement complex algorithms.
+
 */
 
@@ -135,50 +212,4 @@
 implemented in LEMON.
 
-*/
-
-/**
-@defgroup flowalgs Path and Flow Algorithms
-@ingroup galgs
-\brief This group describes the algorithms
-for finding paths and flows in graphs.
-
-This group describes the algorithms
-for finding paths and flows in graphs.
-
-\image html flow.png
-\image latex flow.eps "Graph flow" width=\textwidth
-*/
-
-/**
-@defgroup topology Topology related algorithms
-@ingroup galgs
-\brief This group describes the algorithms
-for discover the topology of the graphs.
-
-This group describes the algorithms
-for discover the topology of the graphs.
-
-\image html edge_biconnected_components.png
-\image latex edge_biconnected_components.eps "bi-edge-connected components" width=\textwidth
-
-*/
-
-/**
-@defgroup matching Matching algorithms in graphs and bipartite graphs
-@ingroup galgs
-\brief This group describes the algorithms
-for find matchings in graphs and bipartite graphs.
-
-This group provides some algorithm objects and function
-to calculate matchings in graphs and bipartite graphs.
-
-\image html bipartite_matching.png
-\image latex bipartite_matching.eps "Bipartite Matching" width=\textwidth
-
-*/
-
-/**
-@defgroup exceptions Exceptions
-This group contains the exceptions thrown by LEMON library
 */
 
@@ -198,11 +229,25 @@
 /**
 @defgroup io_group Input-Output
-Here you can find tools for imporing and exporting graphs and graph related
-data
+\brief Several Graph Input-Output methods
+
+Here you can find tools for importing and exporting graphs 
+and graph related data. Now it supports the LEMON format, the
+dimacs format and the encapsulated postscript format.
+*/
+
+/**
+@defgroup lemon_io Lemon Input-Output
+@ingroup io_group
+\brief Reading and writing LEMON format
+
+Methods for reading and writing LEMON format. More about this
+format you can find on the \ref graph-io-page "Graph Input-Output"
+tutorial pages.
+
 */
 
 /**
 @defgroup section_io Section readers and writers
-@ingroup io_group
+@ingroup lemon_io
 \brief Section readers and writers for lemon Input-Output.
 
@@ -213,5 +258,5 @@
 /**
 @defgroup item_io Item Readers and Writers
-@ingroup io_group
+@ingroup lemon_io
 \brief Item readers and writers for lemon Input-Output.
 
@@ -222,4 +267,18 @@
 
 /**
+@defgroup eps_io Postscript exporting
+@ingroup io_group
+\brief General EPS drawer and graph exporter
+
+This group contains general EPS drawing methods and special
+graph exporting tools. 
+*/
+
+/**
+@defgroup exceptions Exceptions
+This group contains the exceptions thrown by LEMON library
+*/
+
+/**
 @defgroup concept Concepts
 \brief Skeleton classes and concept checking classes
@@ -234,4 +293,5 @@
 
 */
+
 
 /**
Index: doc/images/swap_test.eps
===================================================================
--- doc/images/swap_test.eps	(revision 2084)
+++ doc/images/swap_test.eps	(revision 2084)
@@ -0,0 +1,763 @@
+%!PS-Adobe-2.0 EPSF-2.0
+%%Title: swap_test.eps
+%%Creator: gnuplot 4.0 patchlevel 0
+%%CreationDate: Sat May 13 18:29:57 2006
+%%DocumentFonts: (atend)
+%%BoundingBox: 50 50 338 251
+%%Orientation: Portrait
+%%EndComments
+/gnudict 256 dict def
+gnudict begin
+/Color false def
+/Solid false def
+/gnulinewidth 5.000 def
+/userlinewidth gnulinewidth def
+/vshift -46 def
+/dl {10.0 mul} def
+/hpt_ 31.5 def
+/vpt_ 31.5 def
+/hpt hpt_ def
+/vpt vpt_ def
+/Rounded false def
+/M {moveto} bind def
+/L {lineto} bind def
+/R {rmoveto} bind def
+/V {rlineto} bind def
+/N {newpath moveto} bind def
+/C {setrgbcolor} bind def
+/f {rlineto fill} bind def
+/vpt2 vpt 2 mul def
+/hpt2 hpt 2 mul def
+/Lshow { currentpoint stroke M
+  0 vshift R show } def
+/Rshow { currentpoint stroke M
+  dup stringwidth pop neg vshift R show } def
+/Cshow { currentpoint stroke M
+  dup stringwidth pop -2 div vshift R show } def
+/UP { dup vpt_ mul /vpt exch def hpt_ mul /hpt exch def
+  /hpt2 hpt 2 mul def /vpt2 vpt 2 mul def } def
+/DL { Color {setrgbcolor Solid {pop []} if 0 setdash }
+ {pop pop pop 0 setgray Solid {pop []} if 0 setdash} ifelse } def
+/BL { stroke userlinewidth 2 mul setlinewidth
+      Rounded { 1 setlinejoin 1 setlinecap } if } def
+/AL { stroke userlinewidth 2 div setlinewidth
+      Rounded { 1 setlinejoin 1 setlinecap } if } def
+/UL { dup gnulinewidth mul /userlinewidth exch def
+      dup 1 lt {pop 1} if 10 mul /udl exch def } def
+/PL { stroke userlinewidth setlinewidth
+      Rounded { 1 setlinejoin 1 setlinecap } if } def
+/LTw { PL [] 1 setgray } def
+/LTb { BL [] 0 0 0 DL } def
+/LTa { AL [1 udl mul 2 udl mul] 0 setdash 0 0 0 setrgbcolor } def
+/LT0 { PL [] 1 0 0 DL } def
+/LT1 { PL [4 dl 2 dl] 0 1 0 DL } def
+/LT2 { PL [2 dl 3 dl] 0 0 1 DL } def
+/LT3 { PL [1 dl 1.5 dl] 1 0 1 DL } def
+/LT4 { PL [5 dl 2 dl 1 dl 2 dl] 0 1 1 DL } def
+/LT5 { PL [4 dl 3 dl 1 dl 3 dl] 1 1 0 DL } def
+/LT6 { PL [2 dl 2 dl 2 dl 4 dl] 0 0 0 DL } def
+/LT7 { PL [2 dl 2 dl 2 dl 2 dl 2 dl 4 dl] 1 0.3 0 DL } def
+/LT8 { PL [2 dl 2 dl 2 dl 2 dl 2 dl 2 dl 2 dl 4 dl] 0.5 0.5 0.5 DL } def
+/Pnt { stroke [] 0 setdash
+   gsave 1 setlinecap M 0 0 V stroke grestore } def
+/Dia { stroke [] 0 setdash 2 copy vpt add M
+  hpt neg vpt neg V hpt vpt neg V
+  hpt vpt V hpt neg vpt V closepath stroke
+  Pnt } def
+/Pls { stroke [] 0 setdash vpt sub M 0 vpt2 V
+  currentpoint stroke M
+  hpt neg vpt neg R hpt2 0 V stroke
+  } def
+/Box { stroke [] 0 setdash 2 copy exch hpt sub exch vpt add M
+  0 vpt2 neg V hpt2 0 V 0 vpt2 V
+  hpt2 neg 0 V closepath stroke
+  Pnt } def
+/Crs { stroke [] 0 setdash exch hpt sub exch vpt add M
+  hpt2 vpt2 neg V currentpoint stroke M
+  hpt2 neg 0 R hpt2 vpt2 V stroke } def
+/TriU { stroke [] 0 setdash 2 copy vpt 1.12 mul add M
+  hpt neg vpt -1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt 1.62 mul V closepath stroke
+  Pnt  } def
+/Star { 2 copy Pls Crs } def
+/BoxF { stroke [] 0 setdash exch hpt sub exch vpt add M
+  0 vpt2 neg V  hpt2 0 V  0 vpt2 V
+  hpt2 neg 0 V  closepath fill } def
+/TriUF { stroke [] 0 setdash vpt 1.12 mul add M
+  hpt neg vpt -1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt 1.62 mul V closepath fill } def
+/TriD { stroke [] 0 setdash 2 copy vpt 1.12 mul sub M
+  hpt neg vpt 1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt -1.62 mul V closepath stroke
+  Pnt  } def
+/TriDF { stroke [] 0 setdash vpt 1.12 mul sub M
+  hpt neg vpt 1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt -1.62 mul V closepath fill} def
+/DiaF { stroke [] 0 setdash vpt add M
+  hpt neg vpt neg V hpt vpt neg V
+  hpt vpt V hpt neg vpt V closepath fill } def
+/Pent { stroke [] 0 setdash 2 copy gsave
+  translate 0 hpt M 4 {72 rotate 0 hpt L} repeat
+  closepath stroke grestore Pnt } def
+/PentF { stroke [] 0 setdash gsave
+  translate 0 hpt M 4 {72 rotate 0 hpt L} repeat
+  closepath fill grestore } def
+/Circle { stroke [] 0 setdash 2 copy
+  hpt 0 360 arc stroke Pnt } def
+/CircleF { stroke [] 0 setdash hpt 0 360 arc fill } def
+/C0 { BL [] 0 setdash 2 copy moveto vpt 90 450  arc } bind def
+/C1 { BL [] 0 setdash 2 copy        moveto
+       2 copy  vpt 0 90 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C2 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 90 180 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C3 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 0 180 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C4 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 180 270 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C5 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 0 90 arc
+       2 copy moveto
+       2 copy  vpt 180 270 arc closepath fill
+               vpt 0 360 arc } bind def
+/C6 { BL [] 0 setdash 2 copy moveto
+      2 copy  vpt 90 270 arc closepath fill
+              vpt 0 360 arc closepath } bind def
+/C7 { BL [] 0 setdash 2 copy moveto
+      2 copy  vpt 0 270 arc closepath fill
+              vpt 0 360 arc closepath } bind def
+/C8 { BL [] 0 setdash 2 copy moveto
+      2 copy vpt 270 360 arc closepath fill
+              vpt 0 360 arc closepath } bind def
+/C9 { BL [] 0 setdash 2 copy moveto
+      2 copy  vpt 270 450 arc closepath fill
+              vpt 0 360 arc closepath } bind def
+/C10 { BL [] 0 setdash 2 copy 2 copy moveto vpt 270 360 arc closepath fill
+       2 copy moveto
+       2 copy vpt 90 180 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C11 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 0 180 arc closepath fill
+       2 copy moveto
+       2 copy  vpt 270 360 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C12 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 180 360 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C13 { BL [] 0 setdash  2 copy moveto
+       2 copy  vpt 0 90 arc closepath fill
+       2 copy moveto
+       2 copy  vpt 180 360 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/C14 { BL [] 0 setdash 2 copy moveto
+       2 copy  vpt 90 360 arc closepath fill
+               vpt 0 360 arc } bind def
+/C15 { BL [] 0 setdash 2 copy vpt 0 360 arc closepath fill
+               vpt 0 360 arc closepath } bind def
+/Rec   { newpath 4 2 roll moveto 1 index 0 rlineto 0 exch rlineto
+       neg 0 rlineto closepath } bind def
+/Square { dup Rec } bind def
+/Bsquare { vpt sub exch vpt sub exch vpt2 Square } bind def
+/S0 { BL [] 0 setdash 2 copy moveto 0 vpt rlineto BL Bsquare } bind def
+/S1 { BL [] 0 setdash 2 copy vpt Square fill Bsquare } bind def
+/S2 { BL [] 0 setdash 2 copy exch vpt sub exch vpt Square fill Bsquare } bind def
+/S3 { BL [] 0 setdash 2 copy exch vpt sub exch vpt2 vpt Rec fill Bsquare } bind def
+/S4 { BL [] 0 setdash 2 copy exch vpt sub exch vpt sub vpt Square fill Bsquare } bind def
+/S5 { BL [] 0 setdash 2 copy 2 copy vpt Square fill
+       exch vpt sub exch vpt sub vpt Square fill Bsquare } bind def
+/S6 { BL [] 0 setdash 2 copy exch vpt sub exch vpt sub vpt vpt2 Rec fill Bsquare } bind def
+/S7 { BL [] 0 setdash 2 copy exch vpt sub exch vpt sub vpt vpt2 Rec fill
+       2 copy vpt Square fill
+       Bsquare } bind def
+/S8 { BL [] 0 setdash 2 copy vpt sub vpt Square fill Bsquare } bind def
+/S9 { BL [] 0 setdash 2 copy vpt sub vpt vpt2 Rec fill Bsquare } bind def
+/S10 { BL [] 0 setdash 2 copy vpt sub vpt Square fill 2 copy exch vpt sub exch vpt Square fill
+       Bsquare } bind def
+/S11 { BL [] 0 setdash 2 copy vpt sub vpt Square fill 2 copy exch vpt sub exch vpt2 vpt Rec fill
+       Bsquare } bind def
+/S12 { BL [] 0 setdash 2 copy exch vpt sub exch vpt sub vpt2 vpt Rec fill Bsquare } bind def
+/S13 { BL [] 0 setdash 2 copy exch vpt sub exch vpt sub vpt2 vpt Rec fill
+       2 copy vpt Square fill Bsquare } bind def
+/S14 { BL [] 0 setdash 2 copy exch vpt sub exch vpt sub vpt2 vpt Rec fill
+       2 copy exch vpt sub exch vpt Square fill Bsquare } bind def
+/S15 { BL [] 0 setdash 2 copy Bsquare fill Bsquare } bind def
+/D0 { gsave translate 45 rotate 0 0 S0 stroke grestore } bind def
+/D1 { gsave translate 45 rotate 0 0 S1 stroke grestore } bind def
+/D2 { gsave translate 45 rotate 0 0 S2 stroke grestore } bind def
+/D3 { gsave translate 45 rotate 0 0 S3 stroke grestore } bind def
+/D4 { gsave translate 45 rotate 0 0 S4 stroke grestore } bind def
+/D5 { gsave translate 45 rotate 0 0 S5 stroke grestore } bind def
+/D6 { gsave translate 45 rotate 0 0 S6 stroke grestore } bind def
+/D7 { gsave translate 45 rotate 0 0 S7 stroke grestore } bind def
+/D8 { gsave translate 45 rotate 0 0 S8 stroke grestore } bind def
+/D9 { gsave translate 45 rotate 0 0 S9 stroke grestore } bind def
+/D10 { gsave translate 45 rotate 0 0 S10 stroke grestore } bind def
+/D11 { gsave translate 45 rotate 0 0 S11 stroke grestore } bind def
+/D12 { gsave translate 45 rotate 0 0 S12 stroke grestore } bind def
+/D13 { gsave translate 45 rotate 0 0 S13 stroke grestore } bind def
+/D14 { gsave translate 45 rotate 0 0 S14 stroke grestore } bind def
+/D15 { gsave translate 45 rotate 0 0 S15 stroke grestore } bind def
+/DiaE { stroke [] 0 setdash vpt add M
+  hpt neg vpt neg V hpt vpt neg V
+  hpt vpt V hpt neg vpt V closepath stroke } def
+/BoxE { stroke [] 0 setdash exch hpt sub exch vpt add M
+  0 vpt2 neg V hpt2 0 V 0 vpt2 V
+  hpt2 neg 0 V closepath stroke } def
+/TriUE { stroke [] 0 setdash vpt 1.12 mul add M
+  hpt neg vpt -1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt 1.62 mul V closepath stroke } def
+/TriDE { stroke [] 0 setdash vpt 1.12 mul sub M
+  hpt neg vpt 1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt -1.62 mul V closepath stroke } def
+/PentE { stroke [] 0 setdash gsave
+  translate 0 hpt M 4 {72 rotate 0 hpt L} repeat
+  closepath stroke grestore } def
+/CircE { stroke [] 0 setdash 
+  hpt 0 360 arc stroke } def
+/Opaque { gsave closepath 1 setgray fill grestore 0 setgray closepath } def
+/DiaW { stroke [] 0 setdash vpt add M
+  hpt neg vpt neg V hpt vpt neg V
+  hpt vpt V hpt neg vpt V Opaque stroke } def
+/BoxW { stroke [] 0 setdash exch hpt sub exch vpt add M
+  0 vpt2 neg V hpt2 0 V 0 vpt2 V
+  hpt2 neg 0 V Opaque stroke } def
+/TriUW { stroke [] 0 setdash vpt 1.12 mul add M
+  hpt neg vpt -1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt 1.62 mul V Opaque stroke } def
+/TriDW { stroke [] 0 setdash vpt 1.12 mul sub M
+  hpt neg vpt 1.62 mul V
+  hpt 2 mul 0 V
+  hpt neg vpt -1.62 mul V Opaque stroke } def
+/PentW { stroke [] 0 setdash gsave
+  translate 0 hpt M 4 {72 rotate 0 hpt L} repeat
+  Opaque stroke grestore } def
+/CircW { stroke [] 0 setdash 
+  hpt 0 360 arc Opaque stroke } def
+/BoxFill { gsave Rec 1 setgray fill grestore } def
+/BoxColFill {
+  gsave Rec
+  /Fillden exch def
+  currentrgbcolor
+  /ColB exch def /ColG exch def /ColR exch def
+  /ColR ColR Fillden mul Fillden sub 1 add def
+  /ColG ColG Fillden mul Fillden sub 1 add def
+  /ColB ColB Fillden mul Fillden sub 1 add def
+  ColR ColG ColB setrgbcolor
+  fill grestore } def
+%
+% PostScript Level 1 Pattern Fill routine
+% Usage: x y w h s a XX PatternFill
+%	x,y = lower left corner of box to be filled
+%	w,h = width and height of box
+%	  a = angle in degrees between lines and x-axis
+%	 XX = 0/1 for no/yes cross-hatch
+%
+/PatternFill { gsave /PFa [ 9 2 roll ] def
+    PFa 0 get PFa 2 get 2 div add PFa 1 get PFa 3 get 2 div add translate
+    PFa 2 get -2 div PFa 3 get -2 div PFa 2 get PFa 3 get Rec
+    gsave 1 setgray fill grestore clip
+    currentlinewidth 0.5 mul setlinewidth
+    /PFs PFa 2 get dup mul PFa 3 get dup mul add sqrt def
+    0 0 M PFa 5 get rotate PFs -2 div dup translate
+	0 1 PFs PFa 4 get div 1 add floor cvi
+	{ PFa 4 get mul 0 M 0 PFs V } for
+    0 PFa 6 get ne {
+	0 1 PFs PFa 4 get div 1 add floor cvi
+	{ PFa 4 get mul 0 2 1 roll M PFs 0 V } for
+    } if
+    stroke grestore } def
+%
+/Symbol-Oblique /Symbol findfont [1 0 .167 1 0 0] makefont
+dup length dict begin {1 index /FID eq {pop pop} {def} ifelse} forall
+currentdict end definefont pop
+end
+%%EndProlog
+gnudict begin
+gsave
+50 50 translate
+0.050 0.050 scale
+0 setgray
+newpath
+(Helvetica) findfont 140 scalefont setfont
+1.000 UL
+LTb
+574 280 M
+63 0 V
+4885 0 R
+-63 0 V
+490 280 M
+gsave 0 setgray
+( 0) Rshow
+grestore
+1.000 UL
+LTb
+574 606 M
+63 0 V
+4885 0 R
+-63 0 V
+490 606 M
+gsave 0 setgray
+( 0.5) Rshow
+grestore
+1.000 UL
+LTb
+574 932 M
+63 0 V
+4885 0 R
+-63 0 V
+490 932 M
+gsave 0 setgray
+( 1) Rshow
+grestore
+1.000 UL
+LTb
+574 1257 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 1.5) Rshow
+grestore
+1.000 UL
+LTb
+574 1583 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 2) Rshow
+grestore
+1.000 UL
+LTb
+574 1909 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 2.5) Rshow
+grestore
+1.000 UL
+LTb
+574 2235 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 3) Rshow
+grestore
+1.000 UL
+LTb
+574 2561 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 3.5) Rshow
+grestore
+1.000 UL
+LTb
+574 2887 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 4) Rshow
+grestore
+1.000 UL
+LTb
+574 3212 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 4.5) Rshow
+grestore
+1.000 UL
+LTb
+574 3538 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 5) Rshow
+grestore
+1.000 UL
+LTb
+574 3864 M
+63 0 V
+4885 0 R
+-63 0 V
+-4969 0 R
+gsave 0 setgray
+( 5.5) Rshow
+grestore
+1.000 UL
+LTb
+574 280 M
+0 63 V
+0 3521 R
+0 -63 V
+574 140 M
+gsave 0 setgray
+( 0) Cshow
+grestore
+1.000 UL
+LTb
+1069 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 1000) Cshow
+grestore
+1.000 UL
+LTb
+1564 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 2000) Cshow
+grestore
+1.000 UL
+LTb
+2058 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 3000) Cshow
+grestore
+1.000 UL
+LTb
+2553 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 4000) Cshow
+grestore
+1.000 UL
+LTb
+3048 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 5000) Cshow
+grestore
+1.000 UL
+LTb
+3543 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 6000) Cshow
+grestore
+1.000 UL
+LTb
+4038 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 7000) Cshow
+grestore
+1.000 UL
+LTb
+4532 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 8000) Cshow
+grestore
+1.000 UL
+LTb
+5027 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 9000) Cshow
+grestore
+1.000 UL
+LTb
+5522 280 M
+0 63 V
+0 3521 R
+0 -63 V
+0 -3661 R
+gsave 0 setgray
+( 10000) Cshow
+grestore
+1.000 UL
+LTb
+1.000 UL
+LTb
+574 280 M
+4948 0 V
+0 3584 V
+-4948 0 V
+574 280 L
+1.000 UP
+1.000 UL
+LT5
+LTb
+4871 3731 M
+gsave 0 setgray
+(Original) Rshow
+grestore
+LT5
+4955 3731 M
+399 0 V
+623 521 M
+50 2 V
+49 -7 V
+50 33 V
+49 -25 V
+50 21 V
+49 2 V
+50 0 V
+49 1 V
+50 -6 V
+49 5 V
+50 4 V
+49 4 V
+50 10 V
+49 0 V
+50 2 V
+49 -1 V
+50 9 V
+49 2 V
+50 6 V
+49 36 V
+50 2 V
+49 21 V
+50 8 V
+49 11 V
+49 5 V
+50 5 V
+49 2 V
+50 104 V
+49 -82 V
+50 13 V
+49 4 V
+50 16 V
+49 36 V
+50 32 V
+49 -5 V
+50 32 V
+49 36 V
+50 30 V
+49 -8 V
+50 42 V
+49 28 V
+50 33 V
+49 43 V
+50 58 V
+49 78 V
+50 95 V
+49 126 V
+50 285 V
+49 1708 V
+49 -665 V
+50 -235 V
+49 -143 V
+50 -103 V
+49 -101 V
+50 -118 V
+49 -94 V
+50 -40 V
+49 -57 V
+50 -133 V
+49 5 V
+50 -16 V
+49 57 V
+50 -144 V
+49 -37 V
+50 -48 V
+49 -64 V
+50 17 V
+49 -67 V
+50 -41 V
+49 -18 V
+50 -9 V
+49 10 V
+50 -5 V
+49 -2 V
+49 -26 V
+50 -26 V
+49 -42 V
+50 50 V
+49 -78 V
+50 -51 V
+49 -13 V
+50 9 V
+49 -8 V
+50 0 V
+49 -1 V
+50 -7 V
+49 1 V
+50 -4 V
+49 -13 V
+50 -7 V
+49 -25 V
+50 5 V
+49 -11 V
+50 -16 V
+49 -9 V
+50 -24 V
+49 -2 V
+50 -21 V
+1.000 UL
+LT0
+LTb
+4871 3591 M
+gsave 0 setgray
+(Swapped) Rshow
+grestore
+LT0
+4955 3591 M
+399 0 V
+623 1034 M
+50 -1 V
+49 30 V
+50 -5 V
+49 57 V
+50 -20 V
+49 26 V
+50 0 V
+49 11 V
+50 -10 V
+49 25 V
+50 6 V
+49 6 V
+50 -16 V
+49 21 V
+50 15 V
+49 82 V
+50 -88 V
+49 26 V
+50 37 V
+49 1 V
+50 22 V
+49 64 V
+50 21 V
+49 -3 V
+49 11 V
+50 -8 V
+49 29 V
+50 8 V
+49 6 V
+50 29 V
+49 7 V
+50 119 V
+49 26 V
+50 49 V
+49 32 V
+50 24 V
+49 64 V
+50 -9 V
+49 51 V
+50 35 V
+49 84 V
+50 99 V
+49 77 V
+50 87 V
+49 84 V
+50 212 V
+49 48 V
+50 281 V
+49 771 V
+49 -1861 V
+50 -283 V
+49 -116 V
+50 -117 V
+49 -89 V
+50 -47 V
+49 -54 V
+50 -29 V
+49 -32 V
+50 -39 V
+49 -18 V
+50 14 V
+49 -48 V
+50 -29 V
+49 -22 V
+50 -17 V
+49 -26 V
+50 4 V
+49 -30 V
+50 -12 V
+49 -12 V
+50 -1 V
+49 -21 V
+50 -9 V
+49 21 V
+49 -20 V
+50 -8 V
+49 -7 V
+50 -19 V
+49 -21 V
+50 -11 V
+49 2 V
+50 -6 V
+49 -7 V
+50 2 V
+49 72 V
+50 -87 V
+49 -7 V
+50 5 V
+49 -12 V
+50 1 V
+49 4 V
+50 -2 V
+49 -14 V
+50 -10 V
+49 -2 V
+50 19 V
+49 -29 V
+50 5 V
+1.000 UL
+LTb
+574 280 M
+4948 0 V
+0 3584 V
+-4948 0 V
+574 280 L
+1.000 UP
+stroke
+grestore
+end
+showpage
+%%Trailer
+%%DocumentFonts: Helvetica