Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 174)
+++ lemon/lgf_reader.h	(revision 179)
@@ -2071,5 +2071,5 @@
   /// \ingroup lemon_io
   ///
-  /// \brief Reader for the content of the \ref lgf-format "LGF" file 
+  /// \brief Reader for the contents of the \ref lgf-format "LGF" file 
   ///
   /// This class can be used to read the sections, the map names and
@@ -2077,24 +2077,24 @@
   /// that, which type of graph, which maps and which attributes
   /// should be read from a file, but in general tools (like glemon)
-  /// the content of an LGF file should be guessed somehow. This class
+  /// the contents of an LGF file should be guessed somehow. This class
   /// reads the graph and stores the appropriate information for
   /// reading the graph.
   ///
-  ///\code LgfContent content("graph.lgf"); 
-  /// content.run();
+  ///\code LgfContents contents("graph.lgf"); 
+  /// contents.run();
   ///
   /// // does it contain any node section and arc section
-  /// if (content.nodeSectionNum() == 0 || content.arcSectionNum()) {
+  /// if (contents.nodeSectionNum() == 0 || contents.arcSectionNum()) {
   ///   std::cerr << "Failure, cannot find graph" << std::endl;
   ///   return -1;
   /// }
   /// std::cout << "The name of the default node section : " 
-  ///           << content.nodeSection(0) << std::endl;
+  ///           << contents.nodeSection(0) << std::endl;
   /// std::cout << "The number of the arc maps : " 
-  ///           << content.arcMaps(0).size() << std::endl;
+  ///           << contents.arcMaps(0).size() << std::endl;
   /// std::cout << "The name of second arc map : " 
-  ///           << content.arcMaps(0)[1] << std::endl;
+  ///           << contents.arcMaps(0)[1] << std::endl;
   ///\endcode
-  class LgfContent {    
+  class LgfContents {    
   private:
 
@@ -2122,21 +2122,21 @@
     /// \brief Constructor
     ///
-    /// Construct an \e LGF content reader, which reads from the given
+    /// Construct an \e LGF contents reader, which reads from the given
     /// input stream.
-    LgfContent(std::istream& is) 
+    LgfContents(std::istream& is) 
       : _is(&is), local_is(false) {}
 
     /// \brief Constructor
     ///
-    /// Construct an \e LGF content reader, which reads from the given
+    /// Construct an \e LGF contents reader, which reads from the given
     /// file.
-    LgfContent(const std::string& fn) 
+    LgfContents(const std::string& fn) 
       : _is(new std::ifstream(fn.c_str())), local_is(true) {}
 
     /// \brief Constructor
     ///
-    /// Construct an \e LGF content reader, which reads from the given
+    /// Construct an \e LGF contents reader, which reads from the given
     /// file.
-    LgfContent(const char* fn)
+    LgfContents(const char* fn)
       : _is(new std::ifstream(fn)), local_is(true) {}
 
@@ -2145,5 +2145,5 @@
     /// The copy constructor transfers all data from the other reader,
     /// therefore the copied reader will not be usable more. 
-    LgfContent(LgfContent& other)
+    LgfContents(LgfContents& other)
       : _is(other._is), local_is(other.local_is) {
       
@@ -2164,5 +2164,5 @@
     
     /// \brief Destructor
-    ~LgfContent() {
+    ~LgfContents() {
       if (local_is) delete _is;
     }
@@ -2360,5 +2360,5 @@
   public:
 
-    /// \name Execution of the content reader    
+    /// \name Execution of the contents reader    
     /// @{
 
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 178)
+++ lemon/random.h	(revision 116)
@@ -67,17 +67,7 @@
 #include <vector>
 #include <limits>
-#include <fstream>
 
 #include <lemon/math.h>
 #include <lemon/dim2.h>
-
-#ifndef WIN32
-#include <sys/time.h>
-#include <ctime>
-#include <sys/types.h>
-#include <unistd.h>
-#else
-#include <windows.h>
-#endif
 
 ///\ingroup misc
@@ -537,12 +527,4 @@
   public:
 
-    ///\name Initialization
-    ///
-    /// @{
-
-    ///\name Initialization
-    ///
-    /// @{
-
     /// \brief Default constructor
     ///
@@ -613,71 +595,4 @@
     }
 
-    /// \brief Seeding from file or from process id and time
-    ///
-    /// By default, this function calls the \c seedFromFile() member
-    /// function with the <tt>/dev/urandom</tt> file. If it does not success,
-    /// it uses the \c seedFromTime().
-    /// \return Currently always true.
-    bool seed() {
-#ifndef WIN32
-      if (seedFromFile("/dev/urandom", 0)) return true;
-#endif
-      if (seedFromTime()) return true;
-      return false;
-    }
-    
-    /// \brief Seeding from file
-    ///
-    /// Seeding the random sequence from file. The linux kernel has two
-    /// devices, <tt>/dev/random</tt> and <tt>/dev/urandom</tt> which
-    /// could give good seed values for pseudo random generators (The
-    /// difference between two devices is that the <tt>random</tt> may
-    /// block the reading operation while the kernel can give good
-    /// source of randomness, while the <tt>urandom</tt> does not
-    /// block the input, but it could give back bytes with worse
-    /// entropy).
-    /// \param file The source file
-    /// \param offset The offset, from the file read.
-    /// \return True when the seeding successes.
-#ifndef WIN32
-    bool seedFromFile(const std::string& file = "/dev/urandom", int offset = 0) 
-#else
-    bool seedFromFile(const std::string& file = "", int offset = 0) 
-#endif
-    {
-      std::ifstream rs(file.c_str());
-      const int size = 4;
-      Word buf[size];
-      if (offset != 0 && !rs.seekg(offset)) return false;
-      if (!rs.read(reinterpret_cast<char*>(buf), sizeof(buf))) return false;
-      seed(buf, buf + size);
-      return true;
-    }
-
-    /// \brief Seding from process id and time
-    ///
-    /// Seding from process id and time. This function uses the
-    /// current process id and the current time for initialize the
-    /// random sequence.
-    /// \return Currently always true.
-    bool seedFromTime() { 	
-#ifndef WIN32
-      timeval tv;
-      gettimeofday(&tv, 0);
-      seed(getpid() + tv.tv_sec + tv.tv_usec);
-#else
-      FILETIME time;
-      GetSystemTimeAsFileTime(&time);
-      seed(GetCurrentProcessId() + time.dwHighDateTime + time.dwLowDateTime);
-#endif
-      return true;
-    }
-
-    /// @}
-
-    ///\name Uniform distributions
-    ///
-    /// @{
-
     /// \brief Returns a random real number from the range [0, 1)
     ///
@@ -708,10 +623,4 @@
       return real<Number>() * (b - a) + a; 
     }
-
-    /// @}
-
-    ///\name Uniform distributions
-    ///
-    /// @{
 
     /// \brief Returns a random real number from the range [0, 1)
@@ -771,6 +680,4 @@
       return _random_bits::IntConversion<Number, Word>::convert(core);
     }
-
-    /// @}
 
     unsigned int uinteger() {
@@ -802,6 +709,4 @@
       return bool_producer.convert(core);
     }
-
-    /// @}
 
     ///\name Non-uniform distributions